3 # git-submodule.sh: add, init, update or list git submodules
5 # Copyright (c) 2007 Lars Hjemli
7 dashless=$(basename "$0" | sed -e 's/-/ /')
8 USAGE="[--quiet] add [-b <branch>] [-f|--force] [--name <name>] [--reference <repository>] [--] <repository> [<path>]
9 or: $dashless [--quiet] status [--cached] [--recursive] [--] [<path>...]
10 or: $dashless [--quiet] init [--] [<path>...]
11 or: $dashless [--quiet] deinit [-f|--force] (--all| [--] <path>...)
12 or: $dashless [--quiet] update [--init] [--remote] [-N|--no-fetch] [-f|--force] [--checkout|--merge|--rebase] [--reference <repository>] [--recursive] [--] [<path>...]
13 or: $dashless [--quiet] summary [--cached|--files] [--summary-limit <n>] [commit] [--] [<path>...]
14 or: $dashless [--quiet] foreach [--recursive] <command>
15 or: $dashless [--quiet] sync [--recursive] [--] [<path>...]"
22 wt_prefix=$(git rev-parse --show-prefix)
25 # Restrict ourselves to a vanilla subset of protocols; the URLs
26 # we get are under control of a remote repository, and we do not
27 # want them kicking off arbitrary git-remote-* programs.
29 # If the user has already specified a set of allowed protocols,
30 # we assume they know what they're doing and use that instead.
31 : ${GIT_ALLOW_PROTOCOL=file:git:http:https:ssh}
32 export GIT_ALLOW_PROTOCOL
51 if test "$1" = "#unmatched"
58 # Print a submodule configuration setting
64 # Checks in the usual git-config places first (for overrides),
65 # otherwise it falls back on .gitmodules. This allows you to
66 # distribute project-wide defaults in .gitmodules, while still
67 # customizing individual repositories if necessary. If the option is
68 # not in .gitmodules either, print a default value.
70 get_submodule_config () {
74 value=$(git config submodule."$name"."$option")
77 value=$(git config -f .gitmodules submodule."$name"."$option")
79 printf '%s' "${value:-$default}"
84 n=$(($1 + 0)) 2>/dev/null && test "$n" = "$1"
87 # Sanitize the local git environment for use within a submodule. We
88 # can't simply use clear_local_git_env since we want to preserve some
89 # of the settings from GIT_CONFIG_PARAMETERS.
90 sanitize_submodule_env()
92 save_config=$GIT_CONFIG_PARAMETERS
94 GIT_CONFIG_PARAMETERS=$save_config
95 export GIT_CONFIG_PARAMETERS
99 # Add a new submodule to the working tree, .gitmodules and the index
103 # optional branch is stored in global branch variable
107 # parse $args after "submodule ... add".
113 case "$2" in '') usage ;; esac
124 case "$2" in '') usage ;; esac
129 reference_path="${1#--reference=}"
132 case "$2" in '') usage ;; esac
137 case "$2" in '') usage ;; esac
158 if test -n "$reference_path"
160 is_absolute_path "$reference_path" ||
161 reference_path="$wt_prefix$reference_path"
163 reference="--reference=$reference_path"
169 if test -z "$sm_path"; then
170 sm_path=$(printf '%s\n' "$repo" |
171 sed -e 's|/$||' -e 's|:*/*\.git$||' -e 's|.*[/:]||g')
174 if test -z "$repo" || test -z "$sm_path"; then
178 is_absolute_path "$sm_path" || sm_path="$wt_prefix$sm_path"
180 # assure repo is absolute or relative to parent
183 test -z "$wt_prefix" ||
184 die "$(gettext "Relative path can only be used from the toplevel of the working tree")"
186 # dereference source url relative to parent's url
187 realrepo=$(git submodule--helper resolve-relative-url "$repo") || exit
194 die "$(eval_gettext "repo URL: '\$repo' must be absolute or begin with ./|../")"
199 # multiple //; leading ./; /./; /../; trailing /
200 sm_path=$(printf '%s/\n' "$sm_path" |
210 git ls-files --error-unmatch "$sm_path" > /dev/null 2>&1 &&
211 die "$(eval_gettext "'\$sm_path' already exists in the index")"
213 if test -z "$force" && ! git add --dry-run --ignore-missing "$sm_path" > /dev/null 2>&1
215 eval_gettextln "The following path is ignored by one of your .gitignore files:
217 Use -f if you really want to add it." >&2
221 if test -n "$custom_name"
223 sm_name="$custom_name"
228 # perhaps the path exists and is already a git repo, else clone it
229 if test -e "$sm_path"
231 if test -d "$sm_path"/.git || test -f "$sm_path"/.git
233 eval_gettextln "Adding existing repo at '\$sm_path' to the index"
235 die "$(eval_gettext "'\$sm_path' already exists and is not a valid git repo")"
239 if test -d ".git/modules/$sm_name"
243 echo >&2 "$(eval_gettext "A git directory for '\$sm_name' is found locally with remote(s):")"
244 GIT_DIR=".git/modules/$sm_name" GIT_WORK_TREE=. git remote -v | grep '(fetch)' | sed -e s,^," ", -e s,' (fetch)',, >&2
245 echo >&2 "$(eval_gettext "If you want to reuse this local git directory instead of cloning again from")"
246 echo >&2 " $realrepo"
247 echo >&2 "$(eval_gettext "use the '--force' option. If the local git directory is not the correct repo")"
248 die "$(eval_gettext "or you are unsure what this means choose another name with the '--name' option.")"
250 echo "$(eval_gettext "Reactivating local git directory for submodule '\$sm_name'.")"
253 git submodule--helper clone ${GIT_QUIET:+--quiet} --prefix "$wt_prefix" --path "$sm_path" --name "$sm_name" --url "$realrepo" ${reference:+"$reference"} ${depth:+"$depth"} || exit
255 sanitize_submodule_env
257 # ash fails to wordsplit ${branch:+-b "$branch"...}
259 '') git checkout -f -q ;;
260 ?*) git checkout -f -q -B "$branch" "origin/$branch" ;;
262 ) || die "$(eval_gettext "Unable to checkout submodule '\$sm_path'")"
264 git config submodule."$sm_name".url "$realrepo"
266 git add $force "$sm_path" ||
267 die "$(eval_gettext "Failed to add submodule '\$sm_path'")"
269 git config -f .gitmodules submodule."$sm_name".path "$sm_path" &&
270 git config -f .gitmodules submodule."$sm_name".url "$repo" &&
273 git config -f .gitmodules submodule."$sm_name".branch "$branch"
275 git add --force .gitmodules ||
276 die "$(eval_gettext "Failed to register submodule '\$sm_path'")"
280 # Execute an arbitrary command sequence in each checked out
283 # $@ = command to execute
287 # parse $args after "submodule ... foreach".
309 # dup stdin so that it can be restored when running the external
310 # command in the subshell (and a recursive call to this function)
314 git submodule--helper list --prefix "$wt_prefix" ||
317 while read mode sha1 stage sm_path
319 die_if_unmatched "$mode"
320 if test -e "$sm_path"/.git
322 displaypath=$(git submodule--helper relative-path "$prefix$sm_path" "$wt_prefix")
323 say "$(eval_gettext "Entering '\$displaypath'")"
324 name=$(git submodule--helper name "$sm_path")
326 prefix="$prefix$sm_path/"
327 sanitize_submodule_env
329 sm_path=$(git submodule--helper relative-path "$sm_path" "$wt_prefix") &&
330 # we make $path available to scripts ...
338 if test -n "$recursive"
340 cmd_foreach "--recursive" "$@"
343 die "$(eval_gettext "Stopping at '\$displaypath'; script returned non-zero status.")"
349 # Register submodules in .git/config
351 # $@ = requested paths (default to all)
355 # parse $args after "submodule ... init".
376 git ${wt_prefix:+-C "$wt_prefix"} submodule--helper init ${GIT_QUIET:+--quiet} ${prefix:+--prefix "$prefix"} "$@"
380 # Unregister submodules from .git/config and remove their work tree
382 # $@ = requested paths (use '.' to deinit all submodules)
386 # parse $args after "submodule ... deinit".
414 if test -n "$deinit_all" && test "$#" -ne 0
416 echo >&2 "$(eval_gettext "pathspec and --all are incompatible")"
419 if test $# = 0 && test -z "$deinit_all"
421 die "$(eval_gettext "Use '--all' if you really want to deinitialize all submodules")"
425 git submodule--helper list --prefix "$wt_prefix" "$@" ||
428 while read mode sha1 stage sm_path
430 die_if_unmatched "$mode"
431 name=$(git submodule--helper name "$sm_path") || exit
433 displaypath=$(git submodule--helper relative-path "$sm_path" "$wt_prefix")
435 # Remove the submodule work tree (unless the user already did it)
436 if test -d "$sm_path"
438 # Protect submodules containing a .git directory
439 if test -d "$sm_path/.git"
441 echo >&2 "$(eval_gettext "Submodule work tree '\$displaypath' contains a .git directory")"
442 die "$(eval_gettext "(use 'rm -rf' if you really want to remove it including all of its history)")"
447 git rm -qn "$sm_path" ||
448 die "$(eval_gettext "Submodule work tree '\$displaypath' contains local modifications; use '-f' to discard them")"
451 say "$(eval_gettext "Cleared directory '\$displaypath'")" ||
452 say "$(eval_gettext "Could not remove submodule work tree '\$displaypath'")"
455 mkdir "$sm_path" || say "$(eval_gettext "Could not create empty submodule directory '\$displaypath'")"
457 # Remove the .git/config entries (unless the user already did it)
458 if test -n "$(git config --get-regexp submodule."$name\.")"
460 # Remove the whole section so we have a clean state when
461 # the user later decides to init this submodule again
462 url=$(git config submodule."$name".url)
463 git config --remove-section submodule."$name" 2>/dev/null &&
464 say "$(eval_gettext "Submodule '\$name' (\$url) unregistered for path '\$displaypath'")"
469 is_tip_reachable () (
470 sanitize_submodule_env &&
472 rev=$(git rev-list -n 1 "$2" --not --all 2>/dev/null) &&
476 fetch_in_submodule () (
477 sanitize_submodule_env &&
483 git fetch $(get_default_remote) "$2" ;;
488 # Update each submodule path to correct revision, using clone and checkout as needed
490 # $@ = requested paths (default to all)
494 # parse $args after "submodule ... update".
517 case "$2" in '') usage ;; esac
518 reference="--reference=$2"
534 case "$2" in '') usage ;; esac
542 case "$2" in '') usage ;; esac
565 cmd_init "--" "$@" || return
569 git submodule--helper update-clone ${GIT_QUIET:+--quiet} \
570 ${wt_prefix:+--prefix "$wt_prefix"} \
571 ${prefix:+--recursive-prefix "$prefix"} \
572 ${update:+--update "$update"} \
573 ${reference:+--reference "$reference"} \
574 ${depth:+--depth "$depth"} \
576 "$@" || echo "#unmatched"
579 while read mode sha1 stage just_cloned sm_path
581 die_if_unmatched "$mode"
583 name=$(git submodule--helper name "$sm_path") || exit
584 url=$(git config submodule."$name".url)
585 branch=$(get_submodule_config "$name" branch master)
586 if ! test -z "$update"
588 update_module=$update
590 update_module=$(git config submodule."$name".update)
591 if test -z "$update_module"
593 update_module="checkout"
597 displaypath=$(git submodule--helper relative-path "$prefix$sm_path" "$wt_prefix")
599 if test $just_cloned -eq 1
602 update_module=checkout
604 subsha1=$(sanitize_submodule_env; cd "$sm_path" &&
605 git rev-parse --verify HEAD) ||
606 die "$(eval_gettext "Unable to find current revision in submodule path '\$displaypath'")"
611 if test -z "$nofetch"
613 # Fetch remote before determining tracking $sha1
614 (sanitize_submodule_env; cd "$sm_path" && git-fetch) ||
615 die "$(eval_gettext "Unable to fetch in submodule path '\$sm_path'")"
617 remote_name=$(sanitize_submodule_env; cd "$sm_path" && get_default_remote)
618 sha1=$(sanitize_submodule_env; cd "$sm_path" &&
619 git rev-parse --verify "${remote_name}/${branch}") ||
620 die "$(eval_gettext "Unable to find current ${remote_name}/${branch} revision in submodule path '\$sm_path'")"
623 if test "$subsha1" != "$sha1" || test -n "$force"
626 # If we don't already have a -f flag and the submodule has never been checked out
627 if test -z "$subsha1" && test -z "$force"
632 if test -z "$nofetch"
634 # Run fetch only if $sha1 isn't present or it
635 # is not reachable from a ref.
636 is_tip_reachable "$sm_path" "$sha1" ||
637 fetch_in_submodule "$sm_path" ||
638 die "$(eval_gettext "Unable to fetch in submodule path '\$displaypath'")"
640 # Now we tried the usual fetch, but $sha1 may
641 # not be reachable from any of the refs
642 is_tip_reachable "$sm_path" "$sha1" ||
643 fetch_in_submodule "$sm_path" "$sha1" ||
644 die "$(eval_gettext "Fetched in submodule path '\$displaypath', but it did not contain $sha1. Direct fetching of that commit failed.")"
648 case "$update_module" in
650 command="git checkout $subforce -q"
651 die_msg="$(eval_gettext "Unable to checkout '\$sha1' in submodule path '\$displaypath'")"
652 say_msg="$(eval_gettext "Submodule path '\$displaypath': checked out '\$sha1'")"
656 die_msg="$(eval_gettext "Unable to rebase '\$sha1' in submodule path '\$displaypath'")"
657 say_msg="$(eval_gettext "Submodule path '\$displaypath': rebased into '\$sha1'")"
658 must_die_on_failure=yes
662 die_msg="$(eval_gettext "Unable to merge '\$sha1' in submodule path '\$displaypath'")"
663 say_msg="$(eval_gettext "Submodule path '\$displaypath': merged in '\$sha1'")"
664 must_die_on_failure=yes
667 command="${update_module#!}"
668 die_msg="$(eval_gettext "Execution of '\$command \$sha1' failed in submodule path '\$displaypath'")"
669 say_msg="$(eval_gettext "Submodule path '\$displaypath': '\$command \$sha1'")"
670 must_die_on_failure=yes
673 die "$(eval_gettext "Invalid update mode '$update_module' for submodule '$name'")"
676 if (sanitize_submodule_env; cd "$sm_path" && $command "$sha1")
679 elif test -n "$must_die_on_failure"
681 die_with_status 2 "$die_msg"
683 err="${err};$die_msg"
688 if test -n "$recursive"
691 prefix=$(git submodule--helper relative-path "$prefix$sm_path/" "$wt_prefix")
693 sanitize_submodule_env
700 die_msg="$(eval_gettext "Failed to recurse into submodule path '\$displaypath'")"
703 err="${err};$die_msg"
706 die_with_status $res "$die_msg"
731 sanitize_submodule_env
733 git describe "$2" 2>/dev/null ||
734 git describe --tags "$2" 2>/dev/null ||
735 git describe --contains "$2" 2>/dev/null ||
736 git describe --all --always "$2"
739 test -z "$revname" || revname=" ($revname)"
742 # Show commit summary for submodules in index or working tree
744 # If '--cached' is given, show summary between index and given commit,
745 # or between working tree and given commit
747 # $@ = [commit (default 'HEAD'),] requested paths (default all)
754 # parse $args after "submodule ... summary".
769 isnumber "$summary_limit" || usage
773 summary_limit="${1#--summary-limit=}"
774 isnumber "$summary_limit" || usage
790 test $summary_limit = 0 && return
792 if rev=$(git rev-parse -q --verify --default HEAD ${1+"$1"})
796 elif test -z "$1" || test "$1" = "HEAD"
798 # before the first commit: compare with an empty tree
799 head=$(git hash-object -w -t tree --stdin </dev/null)
800 test -z "$1" || shift
808 die "$(gettext "The --cached option cannot be used with the --files option")"
814 eval "set $(git rev-parse --sq --prefix "$wt_prefix" -- "$@")"
815 # Get modified modules cared by user
816 modules=$(git $diff_cmd $cached --ignore-submodules=dirty --raw $head -- "$@" |
817 sane_egrep '^:([0-7]* )?160000' |
818 while read mod_src mod_dst sha1_src sha1_dst status sm_path
820 # Always show modules deleted or type-changed (blob<->module)
821 if test "$status" = D || test "$status" = T
823 printf '%s\n' "$sm_path"
826 # Respect the ignore setting for --for-status.
827 if test -n "$for_status"
829 name=$(git submodule--helper name "$sm_path")
830 ignore_config=$(get_submodule_config "$name" ignore none)
831 test $status != A && test $ignore_config = all && continue
833 # Also show added or modified modules which are checked out
834 GIT_DIR="$sm_path/.git" git-rev-parse --git-dir >/dev/null 2>&1 &&
835 printf '%s\n' "$sm_path"
839 test -z "$modules" && return
841 git $diff_cmd $cached --ignore-submodules=dirty --raw $head -- $modules |
842 sane_egrep '^:([0-7]* )?160000' |
844 while read mod_src mod_dst sha1_src sha1_dst status name
846 if test -z "$cached" &&
847 test $sha1_dst = 0000000000000000000000000000000000000000
851 sha1_dst=$(GIT_DIR="$name/.git" git rev-parse HEAD)
853 100644 | 100755 | 120000)
854 sha1_dst=$(git hash-object $name)
860 eval_gettextln "unexpected mode \$mod_dst" >&2
867 test $mod_src = 160000 &&
868 ! GIT_DIR="$name/.git" git-rev-parse -q --verify $sha1_src^0 >/dev/null &&
871 test $mod_dst = 160000 &&
872 ! GIT_DIR="$name/.git" git-rev-parse -q --verify $sha1_dst^0 >/dev/null &&
875 display_name=$(git submodule--helper relative-path "$name" "$wt_prefix")
878 case "$missing_src,$missing_dst" in
880 errmsg="$(eval_gettext " Warn: \$display_name doesn't contain commit \$sha1_src")"
883 errmsg="$(eval_gettext " Warn: \$display_name doesn't contain commit \$sha1_dst")"
886 errmsg="$(eval_gettext " Warn: \$display_name doesn't contain commits \$sha1_src and \$sha1_dst")"
891 if test $mod_src = 160000 && test $mod_dst = 160000
893 range="$sha1_src...$sha1_dst"
894 elif test $mod_src = 160000
900 GIT_DIR="$name/.git" \
901 git rev-list --first-parent $range -- | wc -l
903 total_commits=" ($(($total_commits + 0)))"
907 sha1_abbr_src=$(echo $sha1_src | cut -c1-7)
908 sha1_abbr_dst=$(echo $sha1_dst | cut -c1-7)
911 blob="$(gettext "blob")"
912 submodule="$(gettext "submodule")"
913 if test $mod_dst = 160000
915 echo "* $display_name $sha1_abbr_src($blob)->$sha1_abbr_dst($submodule)$total_commits:"
917 echo "* $display_name $sha1_abbr_src($submodule)->$sha1_abbr_dst($blob)$total_commits:"
920 echo "* $display_name $sha1_abbr_src...$sha1_abbr_dst$total_commits:"
924 # Don't give error msg for modification whose dst is not submodule
925 # i.e. deleted or changed to blob
926 test $mod_dst = 160000 && echo "$errmsg"
928 if test $mod_src = 160000 && test $mod_dst = 160000
931 test $summary_limit -gt 0 && limit="-$summary_limit"
932 GIT_DIR="$name/.git" \
933 git log $limit --pretty='format: %m %s' \
934 --first-parent $sha1_src...$sha1_dst
935 elif test $mod_dst = 160000
937 GIT_DIR="$name/.git" \
938 git log --pretty='format: > %s' -1 $sha1_dst
940 GIT_DIR="$name/.git" \
941 git log --pretty='format: < %s' -1 $sha1_src
949 # List all submodules, prefixed with:
950 # - submodule not initialized
951 # + different revision checked out
953 # If --cached was specified the revision in the index will be printed
954 # instead of the currently checked out revision.
956 # $@ = requested paths (default to all)
960 # parse $args after "submodule ... status".
988 git submodule--helper list --prefix "$wt_prefix" "$@" ||
991 while read mode sha1 stage sm_path
993 die_if_unmatched "$mode"
994 name=$(git submodule--helper name "$sm_path") || exit
995 url=$(git config submodule."$name".url)
996 displaypath=$(git submodule--helper relative-path "$prefix$sm_path" "$wt_prefix")
999 say "U$sha1 $displaypath"
1002 if test -z "$url" ||
1004 ! test -d "$sm_path"/.git &&
1005 ! test -f "$sm_path"/.git
1008 say "-$sha1 $displaypath"
1011 if git diff-files --ignore-submodules=dirty --quiet -- "$sm_path"
1013 set_name_rev "$sm_path" "$sha1"
1014 say " $sha1 $displaypath$revname"
1016 if test -z "$cached"
1018 sha1=$(sanitize_submodule_env; cd "$sm_path" && git rev-parse --verify HEAD)
1020 set_name_rev "$sm_path" "$sha1"
1021 say "+$sha1 $displaypath$revname"
1024 if test -n "$recursive"
1027 prefix="$displaypath/"
1028 sanitize_submodule_env
1033 die "$(eval_gettext "Failed to recurse into submodule path '\$sm_path'")"
1038 # Sync remote urls for submodules
1039 # This makes the value for remote.$remote.url match the value
1040 # specified in .gitmodules.
1069 git submodule--helper list --prefix "$wt_prefix" "$@" ||
1072 while read mode sha1 stage sm_path
1074 die_if_unmatched "$mode"
1075 name=$(git submodule--helper name "$sm_path")
1076 url=$(git config -f .gitmodules --get submodule."$name".url)
1078 # Possibly a url relative to parent
1081 # rewrite foo/bar as ../.. to find path from
1082 # submodule work tree to superproject work tree
1083 up_path="$(printf '%s\n' "$sm_path" | sed "s/[^/][^/]*/../g")" &&
1084 # guarantee a trailing /
1085 up_path=${up_path%/}/ &&
1086 # path from submodule work tree to submodule origin repo
1087 sub_origin_url=$(git submodule--helper resolve-relative-url "$url" "$up_path") &&
1088 # path from superproject work tree to submodule origin repo
1089 super_config_url=$(git submodule--helper resolve-relative-url "$url") || exit
1092 sub_origin_url="$url"
1093 super_config_url="$url"
1097 if git config "submodule.$name.url" >/dev/null 2>/dev/null
1099 displaypath=$(git submodule--helper relative-path "$prefix$sm_path" "$wt_prefix")
1100 say "$(eval_gettext "Synchronizing submodule url for '\$displaypath'")"
1101 git config submodule."$name".url "$super_config_url"
1103 if test -e "$sm_path"/.git
1106 sanitize_submodule_env
1108 remote=$(get_default_remote)
1109 git config remote."$remote".url "$sub_origin_url"
1111 if test -n "$recursive"
1113 prefix="$prefix$sm_path/"
1122 # This loop parses the command line arguments to find the
1123 # subcommand name to dispatch. Parsing of the subcommand specific
1124 # options are primarily done by the subcommand implementations.
1125 # Subcommand specific options such as --branch and --cached are
1126 # parsed here as well, for backward compatibility.
1128 while test $# != 0 && test -z "$command"
1131 add | foreach | init | deinit | update | status | summary | sync)
1161 # No command word defaults to "status"
1162 if test -z "$command"
1172 # "-b branch" is accepted only by "add"
1173 if test -n "$branch" && test "$command" != add
1178 # "--cached" is accepted only by "status" and "summary"
1179 if test -n "$cached" && test "$command" != status && test "$command" != summary